diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/update.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/update.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/update.php	2013-10-30 20:29:22.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/update.php	2014-04-03 09:47:09.000000000 +0400
***************
*** 160,168 ****
   * @since 2.3.0
   * @uses $wp_version Used to notify the WordPress version.
   *
   * @return mixed Returns null if update is unsupported. Returns false if check is too soon.
   */
! function wp_update_plugins() {
  	include ABSPATH . WPINC . '/version.php'; // include an unmodified $wp_version
  
  	if ( defined('WP_INSTALLING') )
--- 160,169 ----
   * @since 2.3.0
   * @uses $wp_version Used to notify the WordPress version.
   *
+  * @param array $extra_stats Extra statistics to report to the WordPress.org API.
   * @return mixed Returns null if update is unsupported. Returns false if check is too soon.
   */
! function wp_update_plugins( $extra_stats = array() ) {
  	include ABSPATH . WPINC . '/version.php'; // include an unmodified $wp_version
  
  	if ( defined('WP_INSTALLING') )
***************
*** 201,207 ****
  
  	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
  
! 	if ( $time_not_changed ) {
  		$plugin_changed = false;
  		foreach ( $plugins as $file => $p ) {
  			$new_option->checked[ $file ] = $p['Version'];
--- 202,208 ----
  
  	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
  
! 	if ( $time_not_changed && ! $extra_stats ) {
  		$plugin_changed = false;
  		foreach ( $plugins as $file => $p ) {
  			$new_option->checked[ $file ] = $p['Version'];
***************
*** 250,255 ****
--- 251,260 ----
  		'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' )
  	);
  
+ 	if ( $extra_stats ) {
+ 		$options['body']['update_stats'] = json_encode( $extra_stats );
+ 	}
+ 
  	$url = $http_url = 'http://api.wordpress.org/plugins/update-check/1.1/';
  	if ( $ssl = wp_http_supports( array( 'ssl' ) ) )
  		$url = set_url_scheme( $url, 'https' );
***************
*** 291,299 ****
   * @since 2.7.0
   * @uses $wp_version Used to notify the WordPress version.
   *
   * @return mixed Returns null if update is unsupported. Returns false if check is too soon.
   */
! function wp_update_themes() {
  	include ABSPATH . WPINC . '/version.php'; // include an unmodified $wp_version
  
  	if ( defined( 'WP_INSTALLING' ) )
--- 296,305 ----
   * @since 2.7.0
   * @uses $wp_version Used to notify the WordPress version.
   *
+  * @param array $extra_stats Extra statistics to report to the WordPress.org API.
   * @return mixed Returns null if update is unsupported. Returns false if check is too soon.
   */
! function wp_update_themes( $extra_stats = array() ) {
  	include ABSPATH . WPINC . '/version.php'; // include an unmodified $wp_version
  
  	if ( defined( 'WP_INSTALLING' ) )
***************
*** 343,349 ****
  
  	$time_not_changed = isset( $last_update->last_checked ) && $timeout > ( time() - $last_update->last_checked );
  
! 	if ( $time_not_changed ) {
  		$theme_changed = false;
  		foreach ( $checked as $slug => $v ) {
  			if ( !isset( $last_update->checked[ $slug ] ) || strval($last_update->checked[ $slug ]) !== strval($v) )
--- 349,355 ----
  
  	$time_not_changed = isset( $last_update->last_checked ) && $timeout > ( time() - $last_update->last_checked );
  
! 	if ( $time_not_changed && ! $extra_stats ) {
  		$theme_changed = false;
  		foreach ( $checked as $slug => $v ) {
  			if ( !isset( $last_update->checked[ $slug ] ) || strval($last_update->checked[ $slug ]) !== strval($v) )
***************
*** 390,395 ****
--- 396,405 ----
  		'user-agent'	=> 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' )
  	);
  
+ 	if ( $extra_stats ) {
+ 		$options['body']['update_stats'] = json_encode( $extra_stats );
+ 	}
+ 
  	$url = $http_url = 'http://api.wordpress.org/themes/update-check/1.1/';
  	if ( $ssl = wp_http_supports( array( 'ssl' ) ) )
  		$url = set_url_scheme( $url, 'https' );
***************
*** 584,589 ****
--- 594,601 ----
  			$next += 12 * HOUR_IN_SECONDS;
  		}
  		$next = $next - get_option( 'gmt_offset' ) * HOUR_IN_SECONDS;
+ 		// Add a random number of minutes, so we don't have all sites trying to update exactly on the hour
+ 		$next = $next + rand( 0, 59 ) * MINUTE_IN_SECONDS;
  		wp_schedule_event( $next, 'twicedaily', 'wp_maybe_auto_update' );
  	}
  }
***************
*** 600,613 ****
  add_action( 'load-update-core.php', 'wp_update_plugins' );
  add_action( 'admin_init', '_maybe_update_plugins' );
  add_action( 'wp_update_plugins', 'wp_update_plugins' );
! add_action( 'upgrader_process_complete', 'wp_update_plugins' );
  
  add_action( 'load-themes.php', 'wp_update_themes' );
  add_action( 'load-update.php', 'wp_update_themes' );
  add_action( 'load-update-core.php', 'wp_update_themes' );
  add_action( 'admin_init', '_maybe_update_themes' );
  add_action( 'wp_update_themes', 'wp_update_themes' );
! add_action( 'upgrader_process_complete', 'wp_update_themes' );
  
  add_action( 'wp_maybe_auto_update', 'wp_maybe_auto_update' );
  
--- 612,625 ----
  add_action( 'load-update-core.php', 'wp_update_plugins' );
  add_action( 'admin_init', '_maybe_update_plugins' );
  add_action( 'wp_update_plugins', 'wp_update_plugins' );
! add_action( 'upgrader_process_complete', 'wp_update_plugins', 10, 0 );
  
  add_action( 'load-themes.php', 'wp_update_themes' );
  add_action( 'load-update.php', 'wp_update_themes' );
  add_action( 'load-update-core.php', 'wp_update_themes' );
  add_action( 'admin_init', '_maybe_update_themes' );
  add_action( 'wp_update_themes', 'wp_update_themes' );
! add_action( 'upgrader_process_complete', 'wp_update_themes', 10, 0 );
  
  add_action( 'wp_maybe_auto_update', 'wp_maybe_auto_update' );
  
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/version.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/version.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-includes/version.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-includes/version.php	2014-08-06 22:27:35.000000000 +0400
***************
*** 4,17 ****
   *
   * @global string $wp_version
   */
! $wp_version = '3.7.1';
  
  /**
   * Holds the WordPress DB revision, increments when changes are made to the WordPress DB schema.
   *
   * @global int $wp_db_version
   */
! $wp_db_version = 25824;
  
  /**
   * Holds the TinyMCE version
--- 4,17 ----
   *
   * @global string $wp_version
   */
! $wp_version = '3.7.4';
  
  /**
   * Holds the WordPress DB revision, increments when changes are made to the WordPress DB schema.
   *
   * @global int $wp_db_version
   */
! $wp_db_version = 26149;
  
  /**
   * Holds the TinyMCE version
diff -crBPN --exclude=.htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=.htaccess-dist --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.4.pl /home/packages/qi/SOURCES/wordpress-3.7.1/wp-login.php /home/packages/qi/SOURCES/wordpress-3.7.4/wp-login.php
*** /home/packages/qi/SOURCES/wordpress-3.7.1/wp-login.php	2013-10-30 20:29:21.000000000 +0300
--- /home/packages/qi/SOURCES/wordpress-3.7.4/wp-login.php	2014-08-06 10:40:11.000000000 +0400
***************
*** 557,566 ****
  
  case 'resetpass' :
  case 'rp' :
! 	$user = check_password_reset_key($_GET['key'], $_GET['login']);
  
! 	if ( is_wp_error($user) ) {
! 		if ( $user->get_error_code() === 'expired_key' )
  			wp_redirect( site_url( 'wp-login.php?action=lostpassword&error=expiredkey' ) );
  		else
  			wp_redirect( site_url( 'wp-login.php?action=lostpassword&error=invalidkey' ) );
--- 557,581 ----
  
  case 'resetpass' :
  case 'rp' :
! 	list( $rp_path ) = explode( '?', wp_unslash( $_SERVER['REQUEST_URI'] ) );
! 	$rp_cookie = 'wp-resetpass-' . COOKIEHASH;
! 	if ( isset( $_GET['key'] ) ) {
! 		$value = sprintf( '%s:%s', wp_unslash( $_GET['login'] ), wp_unslash( $_GET['key'] ) );
! 		setcookie( $rp_cookie, $value, 0, $rp_path, COOKIE_DOMAIN, is_ssl(), true );
! 		wp_safe_redirect( remove_query_arg( array( 'key', 'login' ) ) );
! 		exit;
! 	}
! 
! 	if ( isset( $_COOKIE[ $rp_cookie ] ) && 0 < strpos( $_COOKIE[ $rp_cookie ], ':' ) ) {
! 		list( $rp_login, $rp_key ) = explode( ':', wp_unslash( $_COOKIE[ $rp_cookie ] ), 2 );
! 		$user = check_password_reset_key( $rp_key, $rp_login );
! 	} else {
! 		$user = false;
! 	}
  
! 	if ( ! $user || is_wp_error( $user ) ) {
! 		setcookie( $rp_cookie, ' ', time() - YEAR_IN_SECONDS, $rp_path, COOKIE_DOMAIN, is_ssl(), true );
! 		if ( $user && $user->get_error_code() === 'expired_key' )
  			wp_redirect( site_url( 'wp-login.php?action=lostpassword&error=expiredkey' ) );
  		else
  			wp_redirect( site_url( 'wp-login.php?action=lostpassword&error=invalidkey' ) );
***************
*** 584,589 ****
--- 599,605 ----
  
  	if ( ( ! $errors->get_error_code() ) && isset( $_POST['pass1'] ) && !empty( $_POST['pass1'] ) ) {
  		reset_password($user, $_POST['pass1']);
+ 		setcookie( $rp_cookie, ' ', time() - YEAR_IN_SECONDS, $rp_path, COOKIE_DOMAIN, is_ssl(), true );
  		login_header( __( 'Password Reset' ), '<p class="message reset-pass">' . __( 'Your password has been reset.' ) . ' <a href="' . esc_url( wp_login_url() ) . '">' . __( 'Log in' ) . '</a></p>' );
  		login_footer();
  		exit;
***************
*** 595,602 ****
  	login_header(__('Reset Password'), '<p class="message reset-pass">' . __('Enter your new password below.') . '</p>', $errors );
  
  ?>
! <form name="resetpassform" id="resetpassform" action="<?php echo esc_url( site_url( 'wp-login.php?action=resetpass&key=' . urlencode( $_GET['key'] ) . '&login=' . urlencode( $_GET['login'] ), 'login_post' ) ); ?>" method="post" autocomplete="off">
! 	<input type="hidden" id="user_login" value="<?php echo esc_attr( $_GET['login'] ); ?>" autocomplete="off" />
  
  	<p>
  		<label for="pass1"><?php _e('New password') ?><br />
--- 611,618 ----
  	login_header(__('Reset Password'), '<p class="message reset-pass">' . __('Enter your new password below.') . '</p>', $errors );
  
  ?>
! <form name="resetpassform" id="resetpassform" action="<?php echo esc_url( site_url( 'wp-login.php?action=resetpass', 'login_post' ) ); ?>" method="post" autocomplete="off">
! 	<input type="hidden" id="user_login" value="<?php echo esc_attr( $rp_login ); ?>" autocomplete="off" />
  
  	<p>
  		<label for="pass1"><?php _e('New password') ?><br />
